using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace PrintTwoGridsOnSamePage
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl2;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
            this.gridControl2 = new Syncfusion.Windows.Forms.Grid.GridControl();
            this.button1 = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.gridControl2)).BeginInit();
            this.SuspendLayout();
            // 
            // gridControl1
            // 
            this.gridControl1.ColCount = 15;
            this.gridControl1.Location = new System.Drawing.Point(2, 0);
            this.gridControl1.Name = "gridControl1";
            this.gridControl1.RowCount = 100;
            this.gridControl1.Size = new System.Drawing.Size(248, 280);
            this.gridControl1.SmartSizeBox = false;
            this.gridControl1.TabIndex = 0;
            this.gridControl1.Text = "gridControl1";
            // 
            // gridControl2
            // 
            this.gridControl2.ColCount = 15;
            this.gridControl2.Location = new System.Drawing.Point(2, 302);
            this.gridControl2.Name = "gridControl2";
            this.gridControl2.RowCount = 100;
            this.gridControl2.Size = new System.Drawing.Size(296, 280);
            this.gridControl2.SmartSizeBox = false;
            this.gridControl2.TabIndex = 1;
            this.gridControl2.Text = "gridControl2";
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(138, 618);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(112, 23);
            this.button1.TabIndex = 2;
            this.button1.Text = "PrintPreview";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(357, 663);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.gridControl2);
            this.Controls.Add(this.gridControl1);
            this.Name = "Form1";
            this.Text = "Printing two grids in same page";
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.gridControl2)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
            MyGridPrintDocument pd = 
            new MyGridPrintDocument(this.gridControl1, this.gridControl2, true);
			PrintPreviewDialog dlg = new PrintPreviewDialog();
			dlg.Document = pd;
			dlg.ShowDialog();
		}

       
		 
	}

	public class MyGridPrintDocument : GridPrintDocument
	{
		private GridControlBase grid1;
		private GridControlBase grid2;

		public MyGridPrintDocument(GridControlBase grid1, GridControlBase grid2, bool printPreview) : base(grid1, printPreview)
		{
			this.grid1 = grid1;
			this.grid2 = grid2;            
		}

		protected override void OnPrintPage(System.Drawing.Printing.PrintPageEventArgs ev)
		{
			//Do not call baseclass...

			//Set where you want the grid displayed...
			int width = grid1.Model.ColWidths.GetTotal(0, grid1.Model.ColCount);
			int height = grid1.Model.RowHeights.GetTotal(0, grid1.Model.RowCount);
			Rectangle topGridRect = new Rectangle(ev.MarginBounds.Left, ev.MarginBounds.Top, width, height);
			grid1.DrawGrid(ev.Graphics, topGridRect, false);
			//topGridRect.Inflate(1,1);
			ev.Graphics.DrawRectangle(Pens.Black, topGridRect);

			//Set where you want the second grid displayed...
            //width = grid2.Model.ColWidths.GetTotal(0, grid2.Model.ColCount);
            //height = grid2.Model.RowHeights.GetTotal(0, grid2.Model.RowCount);
            //Rectangle botGridRect = new Rectangle(ev.MarginBounds.Left, ev.PageBounds.Height/2, width, height);
            //grid2.DrawGrid(ev.Graphics, botGridRect, false);
            ////botGridRect.Inflate(1,1);
            //ev.Graphics.DrawRectangle(Pens.Black, botGridRect);

		
		}
        protected override void OnEndPrint(PrintEventArgs e)
        {
            base.OnEndPrint(e);
            
        }
	}
}
